//*****************************************************************************
// Klotski Windows Ver1.0 (2024) by takaken
//*****************************************************************************
#include <windows.h>
#include <shlobj.h>
#include <time.h>
#include <process.h>
#include "resource.h"

// \o[
#include "hako10solver.c"

char szTitle[2][50] = {
	"Klotski Optimal Solver Ver1.0 (2024) by takaken",
	"薺 ŒZ\o[ Ver1.0 (2024) by takaken"
};

#define  UM_SOLVE_END  32769
#define  EDITBOX_SIZE	2000

HINSTANCE hInst;
HWND	  hDlog;
HFONT	  hFont;

HDC 	  BuffDC;
HBITMAP   BuffBM;
HDC 	  ItemDC;
HBITMAP   ItemBM;

int 	  PicW;		// `TCY()
int 	  PicH;		// `TCY()
RECT	  Picture;	// `̈
RECT	  Edit;		// ҏẄ
RECT	  Play;		// v[̈
int		  Frame;	// Window̃t[TCY
int		  Title;	// Window̃t[TCY(㕔)

enum { EDIT, PLAY, SOLVE, SHOW, AUTO };	// (MODE)

char IniFile[MAX_PATH];		// ݒt@C
int  MODE;		// 
int  LANG;		// gp 0:English 1:{
int  RULE1;		// AړPƂ		0:No 1:Yes
int  RULE2;		// ̋ē	0:No 1:Yes
int  DISP[20];	// \Ֆ
int  BOX[20] = {// }̑ޔ
	20,40,41,20,
	21,42,43,21,
	20,30,31,20,
	21,10,10,21,
	10, 0, 0,10
};

// \o[
int  Timer;		// Pb^C}[
int  RESULT;	// \o[
char EditBox[EDITBOX_SIZE];	// 𓚌

// v[
int  HOLD_X;
int  HOLD_Y;
int  IsU;
int  IsD;
int  IsL;
int  IsR;
int  VECT;
int  BACK;

// ҏW
int  MOUSE_X;	// }EXW X
int  MOUSE_Y;	// }EXW Y
int  PARTS;		// hbÕp[cR[h
int  GETPOS;	// ێJnꏊ
int  DIFF_X;	// }EXʒuƃhbOp[c`ʒu̍ X
int  DIFF_Y;	// }EXʒuƃhbOp[c`ʒu̍ Y
INT  DRAW;

// \o[𓚍Č
int  TOBOX[34] = {
	99, 99, 99, 99, 99,
	 0,  1,  2,  3, 99,
	 4,  5,  6,  7, 99,
	 8,  9, 10, 11, 99,
	12, 13, 14, 15, 99,
	16, 17, 18, 19, 99,
	99, 99, 99, 99
};
int  MOVE[15][3];
int  INDEX;
int  HOLD;	// ێp[cʒu
cell* NowPtr;
cell* StopPtr;
int  ADD_X;
int  ADD_Y;
int  STEPS;
int  PAUSE;
int  NEXT;	// 0: 1:Oi

// \ꗗ
const char STR[23][2][40] = {
	{"Menu", "j["},		// 0
	{"Edit", "ҏW"},			// 1
	{"Play", "v["},			// 2*
	{"ReStart", "ŏ"},	// 3* (IDC_PLAY)
	{"Solver", "\o["},		// 4*
	{"Cancel", "~"},			// 5* (IDC_SOLVE)
	{"sec","b"},				// 6
	{"Solution", "𓚕\"},	// 7
	{"Top", "擪"},			// 8
	{"Undo", "߂"},			// 9
	{"Redo", "i"},			// 10
	{"Auto", "A"},			// 11*
	{"Pause", "~"},			// 12* (IDC_AUTO)
	{"Steps",""},				// 13
	{"Rule", "["},			// 14 
	{"Continuous Movement", "AړPƂ"},		// 15
	{"Can push other pieces", "̋ē"},	// 16
	{"Clear", ""},		// 17*
	{"Undo", "1߂"},		// 18* (IDC_RESET)
	{"Copy", "Rs["},			// 19
	{"Drag the mouse to place the pieces.", "}EXhbOċzuĉ"},	// 20
	{"Drag the mouse to move piece.", "}EXhbOċ𓮂ĉ"},		// 21
	{"Klotski Solver", "薺\o["},												// 22
};
//*****************************************************************************
// ̕ύX  LANG = 0:English  1:{
//*****************************************************************************
void ShowStr(HWND hWnd)
{
	SetWindowText(hWnd, szTitle[LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_GRP1), STR[0][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_EDIT), STR[1][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_PLAY), STEPS ? STR[3][LANG] : STR[2][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_SOLVE), STR[4][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_TANI), STR[6][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_GRP2), STR[7][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_TOP), STR[8][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_UNDO), STR[9][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_NEXT), STR[10][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_AUTO), STR[11][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_TANI2), STR[13][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_TANI3), STR[13][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_GRP3), STR[14][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_RULE1), STR[15][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_RULE2), STR[16][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_RESET), (MODE == EDIT) ? STR[17][LANG] : STR[18][LANG]);
	SetWindowText(GetDlgItem(hWnd, IDC_COPY), STR[19][LANG]);
	switch (MODE) {
	case EDIT: SetWindowText(GetDlgItem(hWnd, IDC_MSG), STR[20][LANG]); break;
	case PLAY: SetWindowText(GetDlgItem(hWnd, IDC_MSG), STR[21][LANG]); break;
	default: SetWindowText(GetDlgItem(hWnd, IDC_MSG), ""); break;
	}
}
//*****************************************************************************
// Rg[̐F
//*****************************************************************************
LRESULT CtlColor(WPARAM wParam, COLORREF color, HBRUSH hBrush)
{
	HDC hDC = (HDC)wParam;
	SetBkMode(hDC, TRANSPARENT);// wi𓧉
	SetTextColor(hDC, color);	// eLXg̐F
	return (LRESULT)hBrush; 	// wiF̐F(ۑuV)
}
//*****************************************************************************
// Nbv{[hɓ
//*****************************************************************************
void StrToClip(char* str)
{
	HGLOBAL clp;
	PTSTR	mem;

	OpenClipboard(NULL);
	EmptyClipboard();
	clp = GlobalAlloc(GHND | GMEM_SHARE, strlen(str) + 1);
	if (clp) {
		mem = (PTSTR)GlobalLock(clp);
		if (mem) lstrcpy(mem, str);
		GlobalUnlock(clp);
		SetClipboardData(CF_TEXT, clp);
	}
	CloseClipboard();
}
//*****************************************************************************
// sN`[{bNX̕`
//*****************************************************************************
// ێ}[N
void DrawHold(HDC hdc, int x, int y)
{
	HBRUSH hBrush, oBrush;

	hBrush = CreateSolidBrush(RGB(150, 150, 255));
	oBrush = (HBRUSH)SelectObject(hdc, hBrush);
	PatBlt(hdc, x - 15, y - 15, 30, 30, PATCOPY);
	SelectObject(hdc, oBrush);
	DeleteObject(hBrush);
}
// Ă̕`
void DrawPicture(void)
{
	int  x, y, i, hold_flag;
	HFONT h_font, o_font;

	// wi
	SelectObject(BuffDC, CreateSolidBrush(GetSysColor(COLOR_3DFACE)));	// _CAOF
	PatBlt(BuffDC, 0, 0, PicW, PicH, PATCOPY);

	// W
	h_font = CreateFont(24, 0, 0, 0, FW_REGULAR, FALSE, FALSE, FALSE, NULL,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, "Arial");
	o_font = (HFONT)SelectObject(BuffDC, h_font);
	SetTextColor(BuffDC, RGB(0, 0, 0));
	SetBkMode(BuffDC, TRANSPARENT);
	TextOut(BuffDC, 210, 0, "A", 1);
	TextOut(BuffDC, 285, 0, "B", 1);
	TextOut(BuffDC, 360, 0, "C", 1);
	TextOut(BuffDC, 435, 0, "D", 1);
	TextOut(BuffDC, 158, 55, "1", 1);
	TextOut(BuffDC, 158, 130, "2", 1);
	TextOut(BuffDC, 158, 205, "3", 1);
	TextOut(BuffDC, 158, 280, "4", 1);
	TextOut(BuffDC, 158, 355, "5", 1);
	SelectObject(BuffDC, o_font);
	DeleteObject(h_font);

	// p[cXg
	if (MODE == EDIT) {
		BitBlt(BuffDC, 38, 43, 75, 150, ItemDC, 150, 0, SRCCOPY);	// c
		BitBlt(BuffDC, 0, 218, 150, 75, ItemDC, 225, 0, SRCCOPY);	// 
		BitBlt(BuffDC, 38, 318, 75, 75, ItemDC, 225, 75, SRCCOPY);// 1~1
	}

	// Ֆ
	for (y = 0; y < 5; y++)
		for (x = 0; x < 4; x++)
			BitBlt(BuffDC, 180 + 75 * x, 30 + 75 * y, 75, 75, ItemDC, 300, 75, SRCCOPY);
	BitBlt(BuffDC, 255, 255, 150, 150, ItemDC, 375, 0, SRCCOPY);
	for (y = 0; y < 5; y++)
		for (x = 0; x < 4; x++) {
			switch (DISP[y * 4 + x]) {
			case 10: BitBlt(BuffDC, 180 + 75 * x, 30 + 75 * y, 75, 75, ItemDC, 225, 75, SRCCOPY); 			break;
			case 20: BitBlt(BuffDC, 180 + 75 * x, 30 + 75 * y, 75, 150, ItemDC, 150, 0, SRCCOPY); 			break;
			case 30: BitBlt(BuffDC, 180 + 75 * x, 30 + 75 * y, 150, 75, ItemDC, 225, 0, SRCCOPY); 			break;
			case 40: BitBlt(BuffDC, 180 + 75 * x, 30 + 75 * y, 150, 150, ItemDC, 0, 0, SRCCOPY); 			break;
			}
		}

	// ҏW̃hbOp[c
	if (MODE == EDIT && PARTS) {
		switch (PARTS) {
		case 10: BitBlt(BuffDC, MOUSE_X - DIFF_X, MOUSE_Y - DIFF_Y, 75, 75, ItemDC, 225, 75, SRCCOPY); break;
		case 20: BitBlt(BuffDC, MOUSE_X - DIFF_X, MOUSE_Y - DIFF_Y, 75, 150, ItemDC, 150, 0, SRCCOPY); break;
		case 30: BitBlt(BuffDC, MOUSE_X - DIFF_X, MOUSE_Y - DIFF_Y, 150, 75, ItemDC, 225, 0, SRCCOPY); break;
		case 40: BitBlt(BuffDC, MOUSE_X - DIFF_X, MOUSE_Y - DIFF_Y, 150, 150, ItemDC, 0, 0, SRCCOPY); break;
		}
	}


	// v[̃s[Xړ
	if (MODE == PLAY && PARTS && !BACK) {
		for (i = 0; i < INDEX; i++) {
			y = 30 + (MOVE[i][0] / 4) * 75 + ADD_Y;
			x = 180 + (MOVE[i][0] % 4) * 75 + ADD_X;
			switch (MOVE[i][2]) {
			case 10:
				BitBlt(BuffDC, x, y, 75, 75, ItemDC, 225, 75, SRCCOPY);
				break;
			case 20:
				BitBlt(BuffDC, x, y, 75, 150, ItemDC, 150, 0, SRCCOPY);
				break;
			case 30:
				BitBlt(BuffDC, x, y, 150, 75, ItemDC, 225, 0, SRCCOPY);
				break;
			case 40:
				BitBlt(BuffDC, x, y, 150, 150, ItemDC, 0, 0, SRCCOPY);
				break;
			}
		}
		DrawHold(BuffDC, MOUSE_X + 180, MOUSE_Y + 30);
	}

	// 𓚍Č̈ړp[c
	if (((MODE == SHOW || MODE == AUTO) && (ADD_Y || ADD_X)) || (MODE == PLAY && BACK)) {
		for (i = 0; i < INDEX; i++) {
			y = 30 + (MOVE[i][NEXT ^ 1] / 4) * 75 + ADD_Y;
			x = 180 + (MOVE[i][NEXT ^ 1] % 4) * 75 + ADD_X;
			hold_flag = (MOVE[i][NEXT ^ 1] == HOLD) ? TRUE : FALSE;
			switch (MOVE[i][2]) {
			case 10:
				BitBlt(BuffDC, x, y, 75, 75, ItemDC, 225, 75, SRCCOPY);
				if (hold_flag) DrawHold(BuffDC, x + 37, y + 37);
				break;
			case 20:
				BitBlt(BuffDC, x, y, 75, 150, ItemDC, 150, 0, SRCCOPY);
				if (hold_flag) DrawHold(BuffDC, x + 37, y + 75);
				break;
			case 30:
				BitBlt(BuffDC, x, y, 150, 75, ItemDC, 225, 0, SRCCOPY);
				if (hold_flag) DrawHold(BuffDC, x + 75, y + 37);
				break;
			case 40:
				BitBlt(BuffDC, x, y, 150, 150, ItemDC, 0, 0, SRCCOPY);
				if (hold_flag) DrawHold(BuffDC, x + 75, y + 75);
				break;
			}
		}
		// ̕ψ
		if (ADD_Y < 0) ADD_Y -= 25;
		if (ADD_Y > 0) ADD_Y += 25;
		if (ADD_X < 0) ADD_X -= 25;
		if (ADD_X > 0) ADD_X += 25;
	}

	// `w
	if (MODE != EDIT || PARTS == 0) {
		InvalidateRect(hDlog, &Picture, FALSE);
		UpdateWindow(hDlog);
	}
}
//*****************************************************************************
// {^̗LA
//*****************************************************************************
void Enable(HWND hWnd, int status)
{
	BOOL enable;

	MODE = status;
	if (MODE == EDIT || MODE == PLAY) DrawPicture();

	enable = (MODE == SOLVE || MODE == AUTO) ? FALSE : TRUE;
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT), enable);
	EnableWindow(GetDlgItem(hWnd, IDC_PLAY), enable);

	// \o[
	enable = (/*MODE == EDIT ||*/ MODE == AUTO) ? FALSE : TRUE;
	EnableWindow(GetDlgItem(hWnd, IDC_SOLVE), enable);
	SetWindowText(GetDlgItem(hWnd, IDC_SOLVE), (MODE == SOLVE) ? STR[5][LANG] : STR[4][LANG]);
	EnableWindow(GetDlgItem(hWnd, IDC_TIME), enable);
	EnableWindow(GetDlgItem(hWnd, IDC_TANI), enable);

	// 𓚕\
	EnableWindow(GetDlgItem(hWnd, IDC_TOP), (MODE == SHOW) ? TRUE : FALSE);
	EnableWindow(GetDlgItem(hWnd, IDC_UNDO), (MODE == SHOW) ? TRUE : FALSE);
	EnableWindow(GetDlgItem(hWnd, IDC_NEXT), (MODE == SHOW) ? TRUE : FALSE);
	EnableWindow(GetDlgItem(hWnd, IDC_AUTO), (MODE == SHOW || MODE == AUTO) ? TRUE : FALSE);
	SetWindowText(GetDlgItem(hWnd, IDC_AUTO), (MODE == AUTO) ? STR[12][LANG] : STR[11][LANG]);
	EnableWindow(GetDlgItem(hWnd, IDC_STEP), (MODE == SHOW || MODE == AUTO) ? TRUE : FALSE);
	EnableWindow(GetDlgItem(hWnd, IDC_TANI2), (MODE == SHOW || MODE == AUTO) ? TRUE : FALSE);

	// [
	enable = (MODE == SOLVE || MODE == AUTO || (MODE == PLAY && STEPS)) ? FALSE : TRUE;
	EnableWindow(GetDlgItem(hWnd, IDC_RULE1), enable);
	EnableWindow(GetDlgItem(hWnd, IDC_R1NO), enable);
	EnableWindow(GetDlgItem(hWnd, IDC_R1YES), enable);
	EnableWindow(GetDlgItem(hWnd, IDC_RULE2), enable);
	EnableWindow(GetDlgItem(hWnd, IDC_R2NO), enable);
	EnableWindow(GetDlgItem(hWnd, IDC_R2YES), enable);

	// i
	EnableWindow(GetDlgItem(hWnd, IDC_LANG), (MODE == SOLVE || MODE == AUTO) ? FALSE : TRUE);
	switch (MODE) {
	case EDIT: SetWindowText(GetDlgItem(hWnd, IDC_MSG), STR[20][LANG]); break;
	case PLAY: SetWindowText(GetDlgItem(hWnd, IDC_MSG), STR[21][LANG]); break;
	default: SetWindowText(GetDlgItem(hWnd, IDC_MSG), ""); break;
	}
	EnableWindow(GetDlgItem(hWnd, IDC_RESET), (MODE == EDIT || MODE == PLAY) ? TRUE : FALSE);
	SetWindowText(GetDlgItem(hWnd, IDC_RESET), (MODE == EDIT) ? STR[17][LANG] : STR[18][LANG]);
	EnableWindow(GetDlgItem(hWnd, IDC_STEP2), (MODE == PLAY) ? TRUE : FALSE);
	EnableWindow(GetDlgItem(hWnd, IDC_TANI3), (MODE == PLAY) ? TRUE : FALSE);
	EnableWindow(GetDlgItem(hWnd, IDC_COPY), (MODE == SOLVE || MODE == AUTO) ? FALSE : TRUE);
}
//****************************************************************
// \o[
//****************************************************************
// \o[ʕ\
void Result(int mode)
{
	int  i, hold, steps;
	char buff[100];
	cell* ptr;
	char char1[5][2] = {
		".","*", "|", "-", "@"
	};
	char char2[29][3] = {
		"","","","","",
		"A1","B1","C1","D1","",
		"A2","B2","C2","D2","",
		"A3","B3","C3","D3","",
		"A4","B4","C4","D4","",
		"A5","B5","C5","D5"
	};

	// }
	*EditBox = '\0';
	for (i = 0; i < 20; i++) {
		wsprintf(buff, "%s", char1[BOX[i] / 10]);
		strcat_s(EditBox, EDITBOX_SIZE, buff);
		if ((i + 1) % 4 == 0) strcat_s(EditBox, 500, "\r\n");
	}

	// [
	wsprintf(buff, "Rule: %s,%s\r\n", RULE1 ? "Yes" : "No", RULE2 ? "Yes" : "No");
	strcat_s(EditBox, EDITBOX_SIZE, buff);

	// CELLs
	if (RESULT == FALSE) {
		wsprintf(buff, "Cells overflow.\r\n");
		strcat_s(EditBox, EDITBOX_SIZE, buff);
		SetWindowText(GetDlgItem(hDlog, IDC_RESULT), EditBox);
		return;
	}

	// 
	if (RESULT == TRUE) {
		wsprintf(buff, "Unsolvable.\r\n");
		strcat_s(EditBox, EDITBOX_SIZE, buff);
		SetWindowText(GetDlgItem(hDlog, IDC_RESULT), EditBox);
		return;
	}

	// LZ
	if (RESULT == CANCEL) {
		wsprintf(buff, "Canceled.\r\n");
		strcat_s(EditBox, EDITBOX_SIZE, buff);
		SetWindowText(GetDlgItem(hDlog, IDC_RESULT), EditBox);
		return;
	}

	// 𔭌
	if (mode == SOLVE) {
		wsprintf(buff, "Optimal: %d Steps.\r\nSolution:", MinSteps);
	}
	else {
		wsprintf(buff, "Yourself: %d Steps.\r\nSolution:", STEPS);
	}
	strcat_s(EditBox, EDITBOX_SIZE, buff);
	hold = steps = 0;
	for (ptr = StartPtr; ptr != FindPtr; ptr = ptr->next) {
		if (RULE1 == 0 || ptr->hold != hold) {
			wsprintf(buff, "\r\n%3d: %s %s", ++steps, char2[ptr->hold], char2[ptr->steps]);
			strcat_s(EditBox, EDITBOX_SIZE, buff);
		}
		else {
			wsprintf(buff, " %s", char2[ptr->steps]);
			strcat_s(EditBox, EDITBOX_SIZE, buff);
		}
		hold = ptr->steps;
	}
	strcat_s(EditBox, EDITBOX_SIZE, "\r\n");
	SetWindowText(GetDlgItem(hDlog, IDC_RESULT), EditBox);
}
// \o[Jn
void SolverThread(void*)
{
	clock_t st;
	double utime;
	int ut1, ut2;
	char str[10];

	// is\^C}[Jn
	Timer = 0;
	SetTimer(hDlog, 1, 1000, NULL);

	// TJn
	SetWindowText(GetDlgItem(hDlog, IDC_RESULT), "");
	st = clock();
	RESULT = Solve(RULE1, RULE2, DISP);

	// sԂƃXebv
	utime = (double)(clock() - st) / CLOCKS_PER_SEC;
	ut1 = (INT)utime;					// _ȏ
	ut2 = (int)(utime * 100.5) % 100;	// _ȉ
	wsprintf(str, "%d.%02d", ut1, ut2);
	SetWindowText(GetDlgItem(hDlog, IDC_TIME), str);
	wsprintf(str, "0 / %d", MinSteps);
	SetWindowText(GetDlgItem(hDlog, IDC_STEP), str);

	// is\^C}[I
	KillTimer(hDlog, 1);

	// ʕ\
	Result(SOLVE);

	// XbhI
	SendMessage(hDlog, UM_SOLVE_END, 0, 0);
	_endthread();
}
//*****************************************************************************
// 𓚍Č̃s[Ẍړ
//*****************************************************************************
// s[X̃o[(MOVE[][])
void MemberSub(int pos0, int pos1, int piece)
{
	int  i;

	// Stack0[], Stack1[], IDX 
	IDX = 0;
	switch (pos1 - pos0) {
	case -5:	// ֈړ
		switch (piece) {
		case 10: PushU1(pos0, 1, TRUE); break;
		case 20: PushU1(pos0, 2, TRUE); break;
		case 30: PushU2(pos0, 1, TRUE); break;
		case 40: PushU2(pos0, 2, TRUE); break;
		}
		break;
	case 5:		//ֈړ
		switch (piece) {
		case 10: PushD1(pos0, 1, TRUE); break;
		case 20: PushD1(pos0 + 5, 2, TRUE); break;
		case 30: PushD2(pos0, 1, TRUE); break;
		case 40: PushD2(pos0 + 5, 2, TRUE); break;
		}
		break;
	case -1:	// ֈړ
		switch (piece) {
		case 10: PushL1(pos0, 1, TRUE); break;
		case 20: PushL2(pos0, 1, TRUE); break;
		case 30: PushL1(pos0, 2, TRUE); break;
		case 40: PushL2(pos0, 2, TRUE); break;
		}
		break;
	case 1:	// Eֈړ
		switch (piece) {
		case 10: PushR1(pos0, 1, TRUE); break;
		case 20: PushR2(pos0, 1, TRUE); break;
		case 30: PushR1(pos0 + 1, 2, TRUE); break;
		case 40: PushR2(pos0 + 1, 2, TRUE); break;
		}
		break;
	}

	// MOVE[][], INDEX 
	INDEX = 0;
	for (i = 0; i < IDX; i++) {
		if (BOARD[Stack1[i]] % 10) continue;
		MOVE[INDEX][0] = TOBOX[Stack0[i]];	// ړ
		MOVE[INDEX][1] = TOBOX[Stack1[i]];	// ړ
		MOVE[INDEX][2] = BOARD[Stack1[i]];	// s[X̎
		INDEX++;
	}
}
void Member(cell* ptr)
{
	int  pos0, pos1, piece;

	// ptr  BOARD[] ɍČ
	ListToBoard(BOARD, &(ptr->list[0]));
	pos0 = ptr->hold;	// ړ (ڗp)
	pos1 = ptr->steps;	// ړ (ڗp)
	piece = BOARD[pos0];	// s[X̎
	MemberSub(pos0, pos1, piece);
}
// ړ
void MoveEnd(int avc)
{
	int  i, pos;

	// ړs[X𑍂Ēu
	for (i = 0; i < INDEX; i++) {
		pos = MOVE[i][avc];
		switch (MOVE[i][2]) {
		case 10:
			DISP[pos] = 10;
			break;
		case 20:
			DISP[pos] = 20;
			DISP[pos + 4] = 21;
			break;
		case 30:
			DISP[pos] = 30;
			DISP[pos + 1] = 31;
			break;
		case 40:
			DISP[pos] = 40;
			DISP[pos + 1] = 41;
			DISP[pos + 4] = 42;
			DISP[pos + 5] = 43;
			break;
		}
	}
}
//------------------------------------------
// Oɐi
//------------------------------------------
void Next(void)
{
	int  i, pos;

	// MOVE[][]߂
	Member(NowPtr);

	// ێp[c
	HOLD = TOBOX[NowPtr->hold];

	// ړs[X𑍂ď
	for (i = 0; i < INDEX; i++) {
		pos = MOVE[i][0];
		switch (MOVE[i][2]) {
		case 10:
			DISP[pos] = 0;
			break;
		case 20:
			DISP[pos] = 0;
			DISP[pos + 4] = 0;
			break;
		case 30:
			DISP[pos] = 0;
			DISP[pos + 1] = 0;
			break;
		case 40:
			DISP[pos] = 0;
			DISP[pos + 1] = 0;
			DISP[pos + 4] = 0;
			DISP[pos + 5] = 0;
			break;
		}
	}

	// ψ(ADD_Y, ADD_X)߂
	ADD_X = ADD_Y = 0;
	switch (NowPtr->steps - NowPtr->hold) {
	case -5: ADD_Y = -25; break;
	case  5: ADD_Y = 25; break;
	case -1: ADD_X = -25; break;
	case  1: ADD_X = 25; break;
	}

	// `
	DrawPicture();
}
// ǂ܂Őiނׂ
void NextStart(void)
{
	int  hold;
	char str[12];

	// ̒~ʒu(StopPtr)𒲂ׂ
	StopPtr = NowPtr->next;
	if (Rule1) {
		hold = NowPtr->steps;
		while (StopPtr != FindPtr && StopPtr->hold == hold) {
			hold = StopPtr->steps;
			StopPtr = StopPtr->next;
		}
	}
	wsprintf(str, "%d / %d", ++STEPS, MinSteps);
	SetWindowText(GetDlgItem(hDlog, IDC_STEP), str);
	NEXT = 1;
	Next();
	SetTimer(hDlog, 2, 40, NULL);
}
//------------------------------------------
// ɖ߂
//------------------------------------------
void Prev(void)
{
	int  i, pos;
	cell* ptr;

	// prevՖʂ̃|C^
	ptr = NowPtr->prev;

	// prevՖʂMOVE[][]߂
	Member(ptr);

	// prevՖʂ̕ێp[c
	HOLD = TOBOX[ptr->steps];

	// prevՖʂ̈ړs[X𑍂ď
	for (i = 0; i < INDEX; i++) {
		pos = MOVE[i][1];
		switch (MOVE[i][2]) {
		case 10:
			DISP[pos] = 0;
			break;
		case 20:
			DISP[pos] = 0;
			DISP[pos + 4] = 0;
			break;
		case 30:
			DISP[pos] = 0;
			DISP[pos + 1] = 0;
			break;
		case 40:
			DISP[pos] = 0;
			DISP[pos + 1] = 0;
			DISP[pos + 4] = 0;
			DISP[pos + 5] = 0;
			break;
		}
	}

	// ψ(ADD_Y, ADD_X)߂
	ADD_X = ADD_Y = 0;
	switch (ptr->steps - ptr->hold) {
	case -5: ADD_Y = 25; break;
	case  5: ADD_Y = -25; break;
	case -1: ADD_X = 25; break;
	case  1: ADD_X = -25; break;
	}
}
// ǂ܂Ŗ߂邩ׂ
void PrevStart(void)
{
	int  hold;
	char str[12];

	// ̒~ʒu(StopPtr)𒲂ׂ
	StopPtr = NowPtr->prev;
	if (Rule1) {
		hold = StopPtr->hold;
		while (StopPtr != StartPtr && (StopPtr->prev)->steps == hold) {
			hold = (StopPtr->prev)->hold;
			StopPtr = StopPtr->prev;
		}
	}
	wsprintf(str, "%d / %d", --STEPS, MinSteps);
	SetWindowText(GetDlgItem(hDlog, IDC_STEP), str);
	NEXT = 0;
	Prev();
	SetTimer(hDlog, 2, 40, NULL);
}
//*****************************************************************************
// ҏW̃}EXCxg
//*****************************************************************************
// PARTSu邩?
int  PutPos(void)
{
	int  x, y, pos;

	x = (MOUSE_X - 180 - DIFF_X + 37) / 75;
	y = (MOUSE_Y - 30 - DIFF_Y + 37) / 75;
	if (x == 3 && (PARTS == 30 || PARTS == 40)) x = 2;
	if (y == 4 && (PARTS == 20 || PARTS == 40)) y = 3;
	if (x < 0) x = 0;
	if (y < 0) y = 0;
	pos = y * 4 + x;
	switch (PARTS) {
	case 10:
		if (DISP[pos]) return GETPOS;
		break;
	case 20:
		if (DISP[pos]) return GETPOS;
		if (DISP[pos + 4]) return GETPOS;
		break;
	case 30:
		if (DISP[pos]) return GETPOS;
		if (DISP[pos + 1]) return GETPOS;
		break;
	case 40:
		if (DISP[pos]) return GETPOS;
		if (DISP[pos + 1]) return GETPOS;
		if (DISP[pos + 4]) return GETPOS;
		if (DISP[pos + 5]) return GETPOS;
		break;
	}
	return pos;
}
// }EXDOWN
void EditMouseDown(void)
{
	int  x, y, pos;
	RECT  rc;

	if (MOUSE_X < 180) {	// p[cXg
		if (MOUSE_Y < 205) {
			PARTS = 20;
			DIFF_X = 37;
			DIFF_Y = 75;
		}
		else if (MOUSE_Y < 305) {
			PARTS = 30;
			DIFF_X = 75;
			DIFF_Y = 37;
		}
		else {
			PARTS = 10;
			DIFF_X = 37;
			DIFF_Y = 37;
		}
		GETPOS = -1;
	}
	else {	// v[{[h
		x = (MOUSE_X - 180) / 75;
		y = (MOUSE_Y - 30) / 75;
		pos = y * 4 + x;
		PARTS = DISP[pos];
		switch (PARTS) {
		case 21:
			PARTS = 20;
			pos -= 4;
			break;
		case 31:
			PARTS = 30;
			pos -= 1;
			break;
		case 41:
			PARTS = 40;
			pos -= 1;
			break;
		case 42:
			PARTS = 40;
			pos -= 4;
			break;
		case 43:
			PARTS = 40;
			pos -= 5;
			break;
		}
		GETPOS = pos;

		DISP[GETPOS] = BOX[GETPOS] = 0;
		switch (PARTS) {
		case 10:
			DIFF_X = 37;
			DIFF_Y = 37;
			break;
		case 20:
			DISP[GETPOS + 4] = BOX[GETPOS + 4] = 0;
			DIFF_X = 37;
			DIFF_Y = 75;
			break;
		case 30:
			DISP[GETPOS + 1] = BOX[GETPOS + 1] = 0;
			DIFF_X = 75;
			DIFF_Y = 37;
			break;
		case 40:
			DISP[GETPOS + 1] = BOX[GETPOS + 1] = 0;
			DISP[GETPOS + 4] = BOX[GETPOS + 4] = 0;
			DISP[GETPOS + 5] = BOX[GETPOS + 5] = 0;
			DIFF_X = 75;
			DIFF_Y = 75;
			break;
		}
	}
	DRAW = 1;
	SetTimer(hDlog, 3, 40, NULL);

	// hbO͈͂𐧌
	GetWindowRect(hDlog, &rc);
	rc.top += (Title + Edit.top);
	rc.left += (Frame + Edit.left);
	rc.bottom = rc.top + PicH - 30;
	rc.right = rc.left + PicW;
	ClipCursor(&rc);
}
// }EXUP
void EditMouseUp(void)
{
	int  pos;

	// hbO͈͂
	ClipCursor(NULL);

	KillTimer(hDlog, 3);

	if (MOUSE_X < 180) {	// p[cXg
		if (PARTS == 40) {
			DISP[GETPOS] = BOX[GETPOS] = 40;
			DISP[GETPOS + 1] = BOX[GETPOS + 1] = 41;
			DISP[GETPOS + 4] = BOX[GETPOS + 4] = 42;
			DISP[GETPOS + 5] = BOX[GETPOS + 5] = 43;
		}
	}
	else {	// v[{[h
		pos = PutPos();
		if (pos >= 0) {
			switch (PARTS) {
			case 10:
				DISP[pos] = BOX[pos] = 10;
				break;
			case 20:
				DISP[pos] = BOX[pos] = 20;
				DISP[pos + 4] = BOX[pos + 4] = 21;
				break;
			case 30:
				DISP[pos] = BOX[pos] = 30;
				DISP[pos + 1] = BOX[pos + 1] = 31;
				break;
			case 40:
				DISP[pos] = BOX[pos] = 40;
				DISP[pos + 1] = BOX[pos + 1] = 41;
				DISP[pos + 4] = BOX[pos + 4] = 42;
				DISP[pos + 5] = BOX[pos + 5] = 43;
				break;
			}
		}
	}
	PARTS = 0;

	// `
	DrawPicture();
	InvalidateRect(hDlog, &Picture, FALSE);
	UpdateWindow(hDlog);
}
// }EXMOVE
void EditMouseMove(void)
{
	DRAW = 1;
}
//*****************************************************************************
// v[̃}EXCxg
//*****************************************************************************
// v[̔ՖʋL^(BOXWpos0,pos1)
void PlayWrite(int pos0, int pos1)
{
	int  i, c1, c2, c3, c4, pos, list[15];
	static int hold;
	char str[6];
	cell* wptr, * rptr;

	if (RESULT == SOLVED) return;

	c1 = c2 = c3 = c4 = 0;
	for (i = 0; i < 20; i++) {
		pos = INSIDE[i];
		switch (BOARD[pos]) {
		case 10: list[C1S + c1++] = pos; break;
		case 20: list[C2S + c2++] = pos; break;
		case 30: list[C3S + c3++] = pos; break;
		case 40: list[C4S + c4++] = pos; break;
		}
	}

	wptr = &BUCKET[BucketCnt];
	for (i = 0; i < C4E; i++)
		wptr->list[i] = list[i];
	wptr->hold = 0;
	wptr->steps = 0;
	wptr->next = NULL;
	if (BucketCnt) {
		rptr = &BUCKET[BucketCnt - 1];
		wptr->prev = rptr;

		rptr->hold = INSIDE[pos0];
		rptr->steps = INSIDE[pos1];
		rptr->next = wptr;
		if (Rule1 == 0 || hold != pos0) {
			wsprintf(str, "%d", ++STEPS);
			SetWindowText(GetDlgItem(hDlog, IDC_STEP2), str);
		}
		if (STEPS == 1) {
			Enable(hDlog, PLAY);
			SetWindowText(GetDlgItem(hDlog, IDC_PLAY), STEPS ? STR[3][LANG] : STR[2][LANG]);
		}
	}
	else {
		wptr->prev = NULL;
		StartPtr = wptr;
	}
	BucketCnt++;

	NowPtr = wptr;
	hold = pos1;
	if (DISP[13] == 40) RESULT = SOLVED;
}
// v[Jn
void PlayStart(void)
{
	int  i, pos, c0n;

	// ě
	// box[] -> BOARD[]
	c0n = C1N = C2N = C3N = C4N = 0;
	for (i = 0; i < 20; i++) {
		switch (BOX[i]) {
		case  0: c0n++; break;
		case 10: C1N++; break;
		case 20: C2N++; break;
		case 30: C3N++; break;
		case 40: C4N++; break;
		}
		pos = INSIDE[i];
		BOARD[pos] = BOX[i];
	}

	// e̋L^Jnʒu
	C1S = 0;
	C2S = C1N;
	C3S = C1N + C2N;
	C4S = C1N + C2N + C3N;
	C4E = C1N + C2N + C3N + C4N;

	// 
	STEPS = BucketCnt = 0;
	FindPtr = NULL;
	RESULT = FALSE;
	SetWindowText(GetDlgItem(hDlog, IDC_STEP2), "0");

	// zuo^
	PlayWrite(0, 0);
}
// 邩(BOXWHOLD)
void IsUDLR(void)
{
	int  pos;

	Rule1 = RULE1;
	Rule2 = RULE2;

	pos = INSIDE[HOLD];
	switch (PARTS) {
	case 10:
		IsU = PushU1(pos, 1, FALSE);
		IsD = PushD1(pos, 1, FALSE);
		IsL = PushL1(pos, 1, FALSE);
		IsR = PushR1(pos, 1, FALSE);
		break;
	case 20:
		IsU = PushU1(pos, 2, FALSE);
		IsD = PushD1(pos + 5, 2, FALSE);
		IsL = PushL2(pos, 1, FALSE);
		IsR = PushR2(pos, 1, FALSE);
		break;
	case 30:
		IsU = PushU2(pos, 1, FALSE);
		IsD = PushD2(pos, 1, FALSE);
		IsL = PushL1(pos, 2, FALSE);
		IsR = PushR1(pos + 1, 2, FALSE);
		break;
	case 40:
		IsU = PushU2(pos, 2, FALSE);
		IsD = PushD2(pos + 5, 2, FALSE);
		IsL = PushL2(pos, 2, FALSE);
		IsR = PushR2(pos + 1, 2, FALSE);
		break;
	}
}
// ێ̑Ss[Xu(put=0 ߂ put=1 i)
void PlayPut(int  put)
{
	int  i, pos1, pos2;

	for (i = 0; i < INDEX; i++) {
		pos1 = MOVE[i][put];
		pos2 = INSIDE[pos1];
		switch (MOVE[i][2]) {
		case 10:
			DISP[pos1] = BOARD[pos2] = 10;
			break;
		case 20:
			DISP[pos1] = BOARD[pos2] = 20;
			DISP[pos1 + 4] = BOARD[pos2 + 5] = 21;
			break;
		case 30:
			DISP[pos1] = BOARD[pos2] = 30;
			DISP[pos1 + 1] = BOARD[pos2 + 1] = 31;
			break;
		case 40:
			DISP[pos1] = BOARD[pos2] = 40;
			DISP[pos1 + 1] = BOARD[pos2 + 1] = 41;
			DISP[pos1 + 4] = BOARD[pos2 + 5] = 42;
			DISP[pos1 + 5] = BOARD[pos2 + 6] = 43;
			break;
		}
	}
	INDEX = 0;
}
void PlayGet(int pos1)
{
	int  i, pos0, pos2;

	// MOVE[][], INDEX 𓾂
	MemberSub(INSIDE[HOLD], INSIDE[pos1], PARTS);
	Back(0);

	// ړs[X𑍂ď
	for (i = 0; i < INDEX; i++) {
		pos0 = MOVE[i][0];
		pos2 = INSIDE[pos0];
		switch (MOVE[i][2]) {
		case 10:
			DISP[pos0] = BOARD[pos2] = 0;
			break;
		case 20:
			DISP[pos0] = BOARD[pos2] = 0;
			DISP[pos0 + 4] = BOARD[pos2 + 5] = 0;
			break;
		case 30:
			DISP[pos0] = BOARD[pos2] = 0;
			DISP[pos0 + 1] = BOARD[pos2 + 1] = 0;
			break;
		case 40:
			DISP[pos0] = BOARD[pos2] = 0;
			DISP[pos0 + 1] = BOARD[pos2 + 1] = 0;
			DISP[pos0 + 4] = BOARD[pos2 + 5] = 0;
			DISP[pos0 + 5] = BOARD[pos2 + 6] = 0;
			break;
		}
	}
}
// }EXDOWN
void PlayMouseDown(void)
{
	int  x, y;
	RECT  rc;

	if (RESULT == SOLVED) return;

	x = (MOUSE_X - 180) / 75;
	y = (MOUSE_Y - 30) / 75;
	HOLD = y * 4 + x;

	// p[c̑\ʒu()
	switch (DISP[HOLD]) {
	case  0: return;
	case 21: HOLD -= 4; break;
	case 31: HOLD -= 1; break;
	case 41: HOLD -= 1; break;
	case 42: HOLD -= 4; break;
	case 43: HOLD -= 5; break;
	}
	PARTS = DISP[HOLD];
	IsUDLR();
	VECT = 0;

	switch (PARTS) {
	case 10:
		DIFF_X = 37;
		DIFF_Y = 37;
		break;
	case 20:
		DIFF_X = 37;
		DIFF_Y = 75;
		break;
	case 30:
		DIFF_X = 75;
		DIFF_Y = 37;
		break;
	case 40:
		DIFF_X = 75;
		DIFF_Y = 75;
		break;
	}

	// s[X̒SW(BOX̃rbgW)
	MOUSE_X = HOLD_X = (HOLD % 4) * 75 + DIFF_X;
	MOUSE_Y = HOLD_Y = (HOLD / 4) * 75 + DIFF_Y;

	// s[X̒SW(WindowsWɕύX)
	GetWindowRect(hDlog, &rc);
	x = MOUSE_X + (rc.left + Frame + Play.left);
	y = MOUSE_Y + (rc.top + Title + Play.top);
	SetCursorPos(x, y);

	// hbO͈͂𐧌
	GetWindowRect(hDlog, &rc);
	rc.top += (Title + Play.top);
	rc.left += (Frame + Play.left);
	rc.bottom = rc.top + 375;
	rc.right = rc.left + 300;
	ClipCursor(&rc);
}
// }EXUP
void PlayMouseUp(void)
{
	int  x, y, hold;
	char str[10];

	// hbO͈͂
	ClipCursor(NULL);

	if (FindPtr) return;

	x = MOUSE_X - 180;
	y = MOUSE_Y - 30;
	switch (PARTS) {
	case 20: y = y - 34; break;
	case 30: x = x - 34; break;
	case 40: y = y - 34; x = x - 34; break;
	}
	hold = (y / 75) * 4 + (x / 75);
	if (hold == HOLD) {
		PlayPut(0);
	}
	else {
		PlayPut(1);
		hold = HOLD;
		switch (VECT) {
		case 1: hold = HOLD - 4;  break;
		case 2: hold = HOLD + 4;  break;
		case 3: hold = HOLD - 1;  break;
		case 4: hold = HOLD + 1;  break;
		}
		if (HOLD != hold) PlayWrite(HOLD, hold);
	}
	PARTS = VECT = 0;

	DrawPicture();

	if (DISP[13] == 40) {
		RESULT = SOLVED;
		MinSteps = STEPS;
		FindPtr = NowPtr;
		Result(PLAY);
		wsprintf(str, "%d / %d", STEPS, MinSteps);
		SetWindowText(GetDlgItem(hDlog, IDC_STEP), str);
		Enable(hDlog, SHOW);
		if (LANG) {
			MessageBox(hDlog, "܂B", STR[22][LANG], MB_OK | MB_ICONINFORMATION);
		}
		else {
			MessageBox(hDlog, "Congratulations.", STR[22][LANG], MB_OK | MB_ICONINFORMATION);
		}
	}
}
// }EXMOVE
void PlayMouseMove(void)
{
	RECT rc;
	int  u, d, l, r, vect, x, y, pos1, diff;

	if (PARTS == 0) return;
	if (RESULT == SOLVED) return;

	// BOX[]Wɕϊ
	MOUSE_Y -= 30;
	MOUSE_X -= 180;

	u = HOLD_Y - MOUSE_Y; if (u < 0 || !IsU) u = 0;
	d = MOUSE_Y - HOLD_Y; if (d < 0 || !IsD) d = 0;
	l = HOLD_X - MOUSE_X; if (l < 0 || !IsL) l = 0;
	r = MOUSE_X - HOLD_X; if (r < 0 || !IsR) r = 0;
	vect = diff = 0;
	if (u > diff) { diff = u; vect = 1; }
	if (d > diff) { diff = d; vect = 2; }
	if (l > diff) { diff = l; vect = 3; }
	if (r > diff) { diff = r; vect = 4; }
	if (VECT && VECT != vect) {
		PlayPut(0);
		VECT = 0;
	}
	if (diff == 0) return;

	if (diff > 76) diff = 75;
	switch (vect) {
	case 1: MOUSE_X = HOLD_X; MOUSE_Y = HOLD_Y - diff; break;
	case 2: MOUSE_X = HOLD_X; MOUSE_Y = HOLD_Y + diff; break;
	case 3: MOUSE_Y = HOLD_Y; MOUSE_X = HOLD_X - diff; break;
	case 4: MOUSE_Y = HOLD_Y; MOUSE_X = HOLD_X + diff; break;
	}

	ADD_X = ADD_Y = 0;
	switch (vect) {
	case 1: ADD_Y = -diff; pos1 = HOLD - 4;  break;
	case 2: ADD_Y = diff; pos1 = HOLD + 4;  break;
	case 3: ADD_X = -diff; pos1 = HOLD - 1;  break;
	case 4: ADD_X = diff; pos1 = HOLD + 1;  break;
	}

	if (VECT == 0) {
		VECT = vect;
		PlayGet(pos1);
	}
	else if (diff > 75) {
		PlayPut(1);
		PlayWrite(HOLD, pos1);

		MOUSE_Y += 30;
		MOUSE_X += 180;
		PlayMouseDown();
		return;
	}

	DrawPicture();

	// s[X̒SW(WindowsWɕύX)
	GetWindowRect(hDlog, &rc);
	x = MOUSE_X + (rc.left + Frame + Play.left);
	y = MOUSE_Y + (rc.top + Title + Play.top);
	SetCursorPos(x, y);
}
//*****************************************************************************
// EBhȄI
//*****************************************************************************
void QuitWindow(HWND hWnd)
{
	char str1[3], str2[3], str3[3];

	// [
	MemFree();

	// ݒt@Cۑ
	wsprintf(str1, "%d", LANG);
	wsprintf(str2, "%d", RULE1);
	wsprintf(str3, "%d", RULE2);
	WritePrivateProfileString("HAKO", "Lang", str1, IniFile);
	WritePrivateProfileString("HAKO", "Rule1", str2, IniFile);
	WritePrivateProfileString("HAKO", "Rule2", str3, IniFile);

	// efoCX폜
	DeleteDC(ItemDC);
	DeleteDC(BuffDC);
	DeleteObject(BuffBM);
}
//*****************************************************************************
// EBhȄ
//*****************************************************************************
void InitWindow(HWND hWnd)
{
	int  i;
	RECT rcw, rc1, rc2;
	char str1[3], str2[3], str3[3];
	char folder[MAX_PATH], filename[MAX_PATH];
	HANDLE			hf;
	WIN32_FIND_DATA fd;

	// OXLt@C
	GetModuleFileName(NULL, folder, MAX_PATH);
	*(strrchr(folder, '\\')) = '\0';
	wsprintf(filename, "%s\\skin.bmp", folder);

	// 摜foCXReLXgƗʍ쐬
	PicW = 480;
	PicH = 405;
	HDC hdc = GetDC(hWnd);
	BuffDC = CreateCompatibleDC(hdc);
	BuffBM = CreateCompatibleBitmap(hdc, PicW, PicH);
	SelectObject(BuffDC, BuffBM);

	// 摜f[^
	ItemDC = CreateCompatibleDC(hdc);
	hf = FindFirstFile(filename, &fd);
	if (hf == INVALID_HANDLE_VALUE) {
		ItemBM = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP1));
	}
	else {
		FindClose(hf);
		ItemBM = (HBITMAP)LoadImage(hInst, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	}
	SelectObject(ItemDC, ItemBM);

	// ʕ\eLXgŒ蕝tHgɂ
	hFont = CreateFont(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "FixedSys");
	SendMessage(GetDlgItem(hWnd, IDC_RESULT), WM_SETFONT, (WPARAM)hFont, MAKELPARAM(TRUE, 0));

	// Window̃t[ƃ^Cg
	GetWindowRect(hWnd, &rcw);
	GetClientRect(hWnd, &rc1);
	Frame = (rcw.right - rcw.left - rc1.right) / 2;
	Title = (rcw.bottom - rcw.top - rc1.bottom) - Frame;

	// sN`[{bNẌ
	GetWindowRect(GetDlgItem(hWnd, IDC_RESULT), &rc1);
	Picture.left = ((rc1.left - (rcw.left + Frame)) - PicW) / 2;
	GetWindowRect(GetDlgItem(hWnd, IDC_GRP2), &rc1);
	GetWindowRect(GetDlgItem(hWnd, IDC_RESET), &rc2);
	Picture.top = rc1.bottom + (rc2.top - rc1.bottom - PicH) / 2 - (rcw.top + Title);
	Picture.right = Picture.left + PicW;
	Picture.bottom = Picture.top + PicH;

	// ҏẄ
	Edit.top = Picture.top + 30;
	Edit.bottom = Picture.bottom;
	Edit.left = Picture.left;
	Edit.right = Picture.right;

	// u[̈
	Play.top = Picture.top + 30;
	Play.bottom = Picture.bottom;
	Play.left = Picture.left + 180;
	Play.right = Picture.right;

	// ݒt@C
	SHGetSpecialFolderPath(NULL, IniFile, CSIDL_APPDATA, TRUE);
	strcat_s(IniFile, MAX_PATH, "\\takaken");
	CreateDirectory(IniFile, NULL);
	strcat_s(IniFile, MAX_PATH, "\\takaken_hako.ini");

	// ݒt@Cǂݎ
	GetPrivateProfileString("HAKO", "Lang", "0", str1, 3, IniFile);
	GetPrivateProfileString("HAKO", "Rule1", "1", str2, 3, IniFile);
	GetPrivateProfileString("HAKO", "Rule2", "0", str3, 3, IniFile);
	LANG = atoi(str1);
	RULE1 = atoi(str2);
	RULE2 = atoi(str3);

	// [m
	if (!MemAlloc()) {
		MessageBox(hWnd, "Out of memory.", STR[22][LANG], MB_OK);
		EndDialog(hWnd, 0);
		return;
	}

	// ʕ\
	*EditBox = '\0';
	SendMessage(GetDlgItem(hWnd, RULE1 ? IDC_R1YES : IDC_R1NO), BM_SETCHECK, TRUE, 0);
	SendMessage(GetDlgItem(hWnd, RULE2 ? IDC_R2YES : IDC_R2NO), BM_SETCHECK, TRUE, 0);
	SetWindowText(GetDlgItem(hWnd, IDC_TIME), "0.00");
	SetWindowText(GetDlgItem(hWnd, IDC_STEP), "0 / 0");
	SetWindowText(GetDlgItem(hWnd, IDC_STEP2), "0");
	SendMessage(GetDlgItem(hWnd, IDC_PLAY), BM_SETCHECK, TRUE, 0);
	SendMessage(GetDlgItem(hWnd, IDC_LANG), BM_SETCHECK, LANG, 0);
	ShowStr(hWnd);
	for (i = 0; i < 20; i++) DISP[i] = BOX[i];	// }̕
	PlayStart();
	Enable(hWnd, PLAY);
}
//*****************************************************************************
// EBhEvV[W Ԃl(:TRUE	:FALSE)
//*****************************************************************************
BOOL CALLBACK WindowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int  i;
	char str[100];

	switch (msg) {
		// 
	case WM_INITDIALOG:
		// nhۑ
		hDlog = hWnd;
		// C_CAOɃACRt
		SendMessage(hWnd, WM_SETICON, ICON_SMALL,
			(LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1)));
		// EBhȄ
		InitWindow(hWnd);
		return TRUE;
		// R}h
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_EDIT:
			for (i = 0; i < 20; i++) DISP[i] = BOX[i];	// }̕
			SetWindowText(GetDlgItem(hWnd, IDC_TIME), "0.00");
			SetWindowText(GetDlgItem(hWnd, IDC_STEP), "0 / 0");
			SetWindowText(GetDlgItem(hWnd, IDC_STEP2), "0");
			SetWindowText(GetDlgItem(hWnd, IDC_PLAY), STR[2][LANG]);
			PARTS = STEPS = 0;
			Enable(hWnd, EDIT);
			return TRUE;
		case IDC_PLAY:
			for (i = 0; i < 20; i++) DISP[i] = BOX[i];	// }̕
			PlayStart();
			SetWindowText(GetDlgItem(hWnd, IDC_TIME), "0.00");
			SetWindowText(GetDlgItem(hWnd, IDC_STEP), "0 / 0");
			SetWindowText(GetDlgItem(hWnd, IDC_STEP2), "0");
			SetWindowText(GetDlgItem(hWnd, IDC_PLAY), STR[2][LANG]);
			STEPS = 0;
			DrawPicture();
			PlayStart();
			Enable(hWnd, PLAY);
			return TRUE;
		case IDC_SOLVE:
			if (MODE == SOLVE) {
				ThreadBreak = TRUE;
			}
			else {
				for (i = 0; i < 20; i++) DISP[i] = BOX[i];	// }̕
				STEPS = 0;
				Enable(hWnd, SOLVE);
				DrawPicture();
				SendMessage(GetDlgItem(hWnd, IDC_EDIT), BM_SETCHECK, FALSE, 0);
				SendMessage(GetDlgItem(hWnd, IDC_PLAY), BM_SETCHECK, FALSE, 0);
				SetWindowText(GetDlgItem(hWnd, IDC_TIME), "0.00");
				SetWindowText(GetDlgItem(hWnd, IDC_STEP), "0 / 0");
				SetWindowText(GetDlgItem(hWnd, IDC_STEP2), "0");
				SetWindowText(GetDlgItem(hWnd, IDC_PLAY), STR[2][LANG]);
				_beginthread(SolverThread, 0, NULL);
			}
			return TRUE;
		case IDC_TOP:
			ListToBoard(BOARD, &(StartPtr->list[0]));
			for (i = 0; i < 20; i++)
				DISP[i] = BOARD[INSIDE[i]];
			NowPtr = StartPtr;
			STEPS = 0;
			wsprintf(str, "0 / %d", MinSteps);
			SetWindowText(GetDlgItem(hDlog, IDC_STEP), str);
			DrawPicture();
			return TRUE;
		case IDC_UNDO:
			if (NowPtr == StartPtr) return TRUE;
			EnableWindow(GetDlgItem(hWnd, IDC_TOP), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_UNDO), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_NEXT), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_AUTO), FALSE);
			PrevStart();
			return TRUE;
		case IDC_NEXT:
			if (NowPtr == FindPtr) return TRUE;
			EnableWindow(GetDlgItem(hWnd, IDC_TOP), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_UNDO), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_NEXT), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_AUTO), FALSE);
			NextStart();
			return TRUE;
		case IDC_AUTO:
			if (NowPtr == FindPtr) return TRUE;
			if (MODE == AUTO) {
				PAUSE = 1;
				Enable(hWnd, SHOW);
			}
			else {
				PAUSE = 0;
				Enable(hWnd, AUTO);
				NextStart();
			}
			return TRUE;
		case IDC_R1NO:
			RULE1 = 0;
			return TRUE;
		case IDC_R1YES:
			RULE1 = 1;
			return TRUE;
		case IDC_R2NO:
			RULE2 = 0;
			return TRUE;
		case IDC_R2YES:
			RULE2 = 1;
			return TRUE;
		case IDC_LANG:
			LANG = (int)SendMessage(GetDlgItem(hWnd, IDC_LANG), BM_GETCHECK, 0, 0);
			ShowStr(hWnd);
			return TRUE;
		case IDC_RESET:	// EDIT: PLAY:P߂
			if (MODE == EDIT) {	// 
				for (i = 0; i < 20; i++)
					if (DISP[i] < 40) DISP[i] = BOX[i] = 0;
				DrawPicture();
				return TRUE;
			}
			if (MODE == PLAY) {	// P߂
				if (NowPtr == StartPtr) return TRUE;
				EnableWindow(GetDlgItem(hWnd, IDC_RESET), FALSE);
				StopPtr = NowPtr->prev;
				BucketCnt--;
				if (Rule1) {
					int hold = StopPtr->hold;
					while (StopPtr != StartPtr && (StopPtr->prev)->steps == hold) {
						hold = (StopPtr->prev)->hold;
						StopPtr = StopPtr->prev;
						BucketCnt--;
					}
				}
				wsprintf(str, "%d", --STEPS);
				SetWindowText(GetDlgItem(hDlog, IDC_STEP2), str);
				if (STEPS == 0) {
					Enable(hWnd, PLAY);
					SetWindowText(GetDlgItem(hWnd, IDC_PLAY), STEPS ? STR[3][LANG] : STR[2][LANG]);
				}
				NEXT = 0;
				BACK = 1;
				Prev();
				SetTimer(hDlog, 4, 40, NULL);
				return TRUE;
			}
			break;
		case IDC_COPY:
			StrToClip(EditBox);
			MessageBox(hWnd, LANG ? "Nbv{[hɃRs[܂B" : "Copied to clipboard.", STR[22][LANG], MB_OK | MB_ICONINFORMATION);
			return TRUE;
		}
		break;
		// ^C}[Cxg
	case WM_TIMER:
		if (wParam == 1) {	// \o[s̃^C}[\
			wsprintf(str, "%d.00", ++Timer);
			SetWindowText(GetDlgItem(hWnd, IDC_TIME), str);
			return TRUE;
		}
		if (wParam == 2) {	// 𓚍Č
			DrawPicture();
			InvalidateRect(hDlog, &Picture, FALSE);
			UpdateWindow(hDlog);
			if (ADD_Y > 75 || ADD_Y < -75 || ADD_X > 75 || ADD_X < -75) {
				MoveEnd(NEXT);
				if (NEXT == 1) {
					NowPtr = NowPtr->next;
					if (NowPtr == StopPtr) {
						ADD_X = ADD_Y = 0;
						KillTimer(hDlog, 2);
						if (PAUSE) {
							Enable(hWnd, SHOW);
							return TRUE;
						}
						if (MODE != AUTO || NowPtr == FindPtr) {
							if (DISP[13] == 40) {
								DrawPicture();
							}
							if (MODE == AUTO) {
								Enable(hWnd, SHOW);
							}
							else {
								EnableWindow(GetDlgItem(hWnd, IDC_TOP), TRUE);
								EnableWindow(GetDlgItem(hWnd, IDC_UNDO), TRUE);
								EnableWindow(GetDlgItem(hWnd, IDC_NEXT), TRUE);
								EnableWindow(GetDlgItem(hWnd, IDC_AUTO), TRUE);
							}
							return TRUE;
						}
						Sleep(200);
						NextStart();
						return TRUE;
					}
					Next();
				}
				else {
					NowPtr = NowPtr->prev;
					if (NowPtr == StopPtr) {
						ADD_X = ADD_Y = 0;
						KillTimer(hDlog, 2);
						if (NowPtr == StartPtr) {
							DrawPicture();
						}
						EnableWindow(GetDlgItem(hWnd, IDC_TOP), TRUE);
						EnableWindow(GetDlgItem(hWnd, IDC_UNDO), TRUE);
						EnableWindow(GetDlgItem(hWnd, IDC_NEXT), TRUE);
						EnableWindow(GetDlgItem(hWnd, IDC_AUTO), TRUE);
						return TRUE;
					}
					Prev();
				}
			}
			return TRUE;
		}
		if (wParam == 3) {	// ҏWhbO
			if (DRAW) {
				DrawPicture();
				InvalidateRect(hDlog, &Picture, FALSE);
				UpdateWindow(hDlog);
				DRAW = 0;
			}
			return TRUE;
		}
		if (wParam == 4) {	// PLAY[߂]
			DrawPicture();
			InvalidateRect(hDlog, &Picture, FALSE);
			UpdateWindow(hDlog);
			if (ADD_Y > 75 || ADD_Y < -75 || ADD_X > 75 || ADD_X < -75) {
				MoveEnd(0);
				NowPtr = NowPtr->prev;
				if (NowPtr == StopPtr) {
					ADD_X = ADD_Y = BACK = 0;
					KillTimer(hDlog, 4);
					cell* ptr = &BUCKET[BucketCnt - 1];
					ListToBoard(BOARD, &(ptr->list[0]));
					DrawPicture();
					EnableWindow(GetDlgItem(hWnd, IDC_RESET), TRUE);
					return TRUE;
				}
				Prev();
			}
			return TRUE;
		}
		break;
		// }EX_E
	case WM_LBUTTONDOWN:
		if (MODE != EDIT && MODE != PLAY) break;
		// }EXWPictureW
		MOUSE_X = (int)LOWORD(lParam) - Picture.left;
		MOUSE_Y = (int)HIWORD(lParam) - Picture.top;
		// MODEɑΉ (L͈͂̊mFƎs)
		if (MODE == EDIT) {	// EDIT̈mF
			if (MOUSE_X < 0 || MOUSE_X > PicW || MOUSE_Y < 30 || MOUSE_Y > PicH) return FALSE;
			EditMouseDown();
		}
		else {	// v[̈mF
			if (MOUSE_X < 180 || MOUSE_X > PicW || MOUSE_Y < 30 || MOUSE_Y > PicH) return FALSE;
			PlayMouseDown();
		}
		return TRUE;
		// }EXAbv
	case WM_LBUTTONUP:
		if (MODE != EDIT && MODE != PLAY) break;
		// }EXWPictureW
		MOUSE_X = (int)LOWORD(lParam) - Picture.left;
		MOUSE_Y = (int)HIWORD(lParam) - Picture.top;
		// MODEɑΉ
		if (MODE == EDIT) { EditMouseUp(); }
		else { PlayMouseUp(); }
		return TRUE;
		// }EX[u
	case WM_MOUSEMOVE:
		if (MODE != EDIT && MODE != PLAY) break;
		// }EXWPictureW
		MOUSE_X = (int)LOWORD(lParam) - Picture.left;
		MOUSE_Y = (int)HIWORD(lParam) - Picture.top;
		// MODEɑΉ
		if (MODE == EDIT) { EditMouseMove(); }
		else { PlayMouseMove(); }
		return TRUE;
		// \o[I
	case UM_SOLVE_END:
		switch (RESULT) {
		case FALSE:
			SendMessage(GetDlgItem(hWnd, IDC_PLAY), BM_SETCHECK, TRUE, 0);
			Enable(hWnd, PLAY);
			PlayStart();
			MessageBox(hWnd, LANG ? "T悪słB" : "Overflow.", STR[22][LANG], MB_OK | MB_ICONINFORMATION);
			break;
		case TRUE:
			SendMessage(GetDlgItem(hWnd, IDC_PLAY), BM_SETCHECK, TRUE, 0);
			Enable(hWnd, PLAY);
			PlayStart();
			MessageBox(hWnd, LANG ? "݂܂B" : "Unsolvable.", STR[22][LANG], MB_OK | MB_ICONINFORMATION);
			break;
		case SOLVED:
			Enable(hWnd, SHOW);
			STEPS = 0;
			NowPtr = StartPtr;
			if (LANG) {
				wsprintf(str, "܂BŒZ %d ", MinSteps);
			}
			else {
				wsprintf(str, "Solved. Optimal %d Steps.", MinSteps);
			}
			MessageBox(hWnd, str, STR[22][LANG], MB_OK | MB_ICONINFORMATION);
			break;
		case CANCEL:
			SendMessage(GetDlgItem(hWnd, IDC_PLAY), BM_SETCHECK, TRUE, 0);
			Enable(hWnd, PLAY);
			PlayStart();
			MessageBox(hWnd, LANG ? "~܂B" : "Canceled.", STR[22][LANG], MB_OK | MB_ICONINFORMATION);
			break;
		}
		return TRUE;
		// ĕ`
	case WM_PAINT:
		PAINTSTRUCT ps;
		BeginPaint(hWnd, &ps);
		BitBlt(ps.hdc, Picture.left, Picture.top, PicW, PicH, BuffDC, 0, 0, SRCCOPY);
		EndPaint(hWnd, &ps);
		return TRUE;
		// X^eBbNeLXgF
	case WM_CTLCOLORSTATIC:
		if ((HWND)lParam == GetDlgItem(hWnd, IDC_MSG))
			return (BOOL)CtlColor(wParam, RGB(0, 0, 255), CreateSolidBrush(GetSysColor(COLOR_3DFACE)));
		break;
		// I
	case WM_CLOSE:
		// EBhȄI
		QuitWindow(hWnd);
		// C_CAO
		EndDialog(hWnd, 0);
		return TRUE;
	}
	return FALSE;
}
//*****************************************************************************
// Gg[|Cg
//*****************************************************************************
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR lpCmdLine, int nCmdShow)
{
	// CX^Xۑ
	hInst = hInstance;

	// C_CAOJ
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)WindowProc);

	return 0;
}
